require 'open-uri'
require 'net/http'

BEGIN {
  def get_response(url)
    begin
      url_str = URI.parse(url)
      $origin = File.dirname(__FILE__)
      response = Net::HTTP.get_response(url_str)
      code = response.body
      status = response.code
      raise '网络请求出错误,使用本地版本' unless status == '200'

      $WORK_DIR_Source = Dir.home() + '/.cocoapods-BDTransform'
      lastDir = Dir::pwd
      system("rm -rf #{$WORK_DIR_Source}/AweToSource") if File::exist?("#{$WORK_DIR_Source}/AweToSource")
      Pathname.new($WORK_DIR_Source).mkdir unless File::directory?($WORK_DIR_Source)
      Dir.chdir($WORK_DIR_Source)
      aFile = File.new("AweToSource", "a+")
      if aFile
        aFile.syswrite(code)
        Dir.chdir(lastDir)
      else
        use_PlaceHoldScript
      end
    rescue Exception => ex
      p ex
      use_PlaceHoldScript
    end
  end

  def use_PlaceHoldScript
    $WORK_DIR_Source = $origin
  end
  require File.dirname(__FILE__)+'/../../gem_version.rb'
  get_response("http://tosv.byted.org/obj/iosbinary/cocoapods-BDTransform/#{CocoapodsBdtransform::VERSION}/AweToSource")

}
module Pod
  class Command
    class Bdtransform
      class ToSource < Bdtransform
        self.summary = 'Transform Pods from binary to source Note: only support for `.a` currently'

        self.description = <<-DESC
        Transform Pods from binary to source Note: only support for .a currently. Warning: You should use `bd_pod_extentions (6.3.0)` to install your Project
        DESC

        self.arguments = [
          CLAide::Argument.new('podName', true),
        ]

        def initialize(argv)
          
          @bd_transform_pod = argv.arguments
          
        end

        def validate!

          help! 'A Pod name is required.' unless @bd_transform_pod.count > 0
        end

        def run
          cdir = $WORK_DIR_Source
          File::chmod(0777,"#{cdir}/AweToSource") if $WORK_DIR_Source == Dir.home() + '/.cocoapods-BDTransform'
          if !@bd_transform_pod.empty?
            string = @bd_transform_pod.to_s
            string = string.gsub("\"","").gsub("[","").gsub("]","").gsub(","," ")
            system("#{cdir}/AweToSource #{string}")
          end
        end
      end
    end
  end
end
